/*
	Serial Camera Client 
	Version 11/24/2010-A
	(C) 2010 Jason Hunt nulluser@gmail.com

	This program is free software; you can redistribute it and/or
    	modify it under the terms of the GNU General Public License
    	as published by the Free Software Foundation; either version 2
    	of the License, or (at your option) any later version.

    	This program is distributed in the hope that it will be useful,
    	but WITHOUT ANY WARRANTY; without even the implied warranty of
    	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    	GNU General Public License for more details.

    	You should have received a copy of the GNU General Public License
    	along with this program; if not, write to the Free Software
    	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/



#ifndef SERIAL_H
#define SERIAL_H

#define SERIAL_SEND_SIZE       7          // Size of control packet
#define SERIAL_RECV_SIZE       5          // Size of  telemetry packet

void start_serial( unsigned int baud );
void stop_serial( void );
void serial_reset( void );


int serial_send (unsigned char *buffer, unsigned int len) ;
int serial_read(unsigned char *buffer, unsigned int len);
void flush_serial( void );

//void show_buffer(char *header, unsigned char data[], int len, bool display);

int serial_transfer(unsigned char device_id,
                        unsigned char *send_buff, int send_bytes,  
                        unsigned char *recv_buff, int recv_bytes);
                        


extern char serial_port[];

#endif



